<template>
  <div class="priceTemplate">
    <div class="heading _h1">{{ createTitle }}</div>
    <div
      v-if="templateType === 'new'"
      class="paragraph">
      Выберите, какие данные из прайса вы хотите показывать и укажите порядковые номера колонок в файле с прайсом, в
      которых эти данные приводятся
    </div>
    <div class="priceTemplate-settings">
      <div class="priceTemplate-item">
        <div class="priceLabel">Тип запчастей*</div>
        <AppInputRadio
          class="_filter"
          name="partType"
          :value="currentPartType"
          @input="changePartType($event, currentPartType)"
          :list="[
            {label:'Новые', value:$options.partTypes.ORIGIN,},
            {label:'Контрактные (б/у)', value:$options.partTypes.CONTRACT,},
            {label:'Шины', value:$options.partTypes.TYRES,},
            {label:'Диски', value:$options.partTypes.WHEELS,}]"/>
      </div>

      <TemplateOriginParts
        v-if="currentPartType === $options.partTypes.ORIGIN"
        :is-in-modal="isInModal"/>

      <TemplateContractParts
        v-if="currentPartType === $options.partTypes.CONTRACT"
        :is-in-modal="isInModal"/>

      <TemplateTyresParts
        v-if="currentPartType === $options.partTypes.TYRES"
        :is-in-modal="isInModal"/>

      <TemplateWheelsParts
        v-if="currentPartType === $options.partTypes.WHEELS"
        :is-in-modal="isInModal"/>

    </div>
  </div>
</template>

<script>
import AppInputRadio from '~/components/redesign/app-input/app-input-radio';
import TemplateOriginParts from '~/components/redesign/cabinet/price-upload/template-origin-parts';
import TemplateContractParts from '~/components/redesign/cabinet/price-upload/template-contract-parts';
import TemplateTyresParts from '~/components/redesign/cabinet/price-upload/template-tyres-parts';
import TemplateWheelsParts from '~/components/redesign/cabinet/price-upload/template-wheels-parts';

import PartTypes from '~/assets/js/enums/price-upload/part-types';
import AppSelect from '../../app-select/app-select';

export default {
  name: 'PriceTemplate',
  components: {
    AppSelect,
    TemplateContractParts,
    TemplateOriginParts,
    TemplateTyresParts,
    TemplateWheelsParts,
    AppInputRadio,
  },
  props: {
    templateType: {
      type: String,
      default: 'new',
    },
    isInModal: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      currentPartType: 'origin',
    };
  },
  computed: {
    createTitle() {
      let title = 'Новый шаблон';
      if (this.templateType !== 'new') {
        title = 'Редактирование шаблона';
      }

      return title;
    },
  },
  created() {
    this.$options.partTypes = PartTypes;
  },
  methods: {
    changePartType(target) {
      if (!Object.values(PartTypes).includes(target)) {
        return false;
      }
      this.currentPartType = target;

      return true;
    },
  },
};
</script>

<style lang="postcss">
  .priceTemplate {
    &-item {
      display: flex;
      justify-content: flex-start;
      align-items: center;
      padding-top: 1rem;
    }

    .paragraph {
      padding: 0.5rem 0;
      max-width: 600px;
    }

    .separator {
      display: block;
      width: 100%;
      margin: 1.5rem 0 0.5rem;
      border-bottom: 1px solid var(--border-color-main);
    }

    .templateForm {
      &-item {
        display: flex;
        justify-content: flex-start;
        align-items: center;
        padding-top: 1rem;

        &._submit {
          padding-top: 2.5rem;
        }

        .input {
          width: auto;

          + .input {
            margin-left: 1rem;
          }

          .input-message-error {
            position: absolute;
            top: -0.875rem;
            display: block;
            padding: 0;
            margin: 0;
            font-size: 0.6875rem;
            line-height: 1rem;
            white-space: nowrap;
          }
        }

        .input._name {
          width: 27rem;
          flex-shrink: 0;
        }

        .input._info {
          width: 27rem;
          max-width: 30vw;
          flex-shrink: 0;
        }

        .input._seller {
          width: 16rem;
          flex-shrink: 0;
        }

        .input._delivery-time {
          flex-shrink: 0;
          width: 3rem;
          .input-field {
            height: var(--select-small-height);
            min-height: var(--select-small-height);
          }
          + .inputRadio {
            margin-left: 1rem;
          }
        }

        .inputCheck-label {
          color: var(--color-main);
        }

        .multiselect._column {
          width: 9.5rem;
          min-width: 9.5rem;
        }

        .buttonQuestion {
          margin: auto 1.5rem auto 1rem;
        }

        .buttonSubmit {
          width: 15.25rem;
        }
      }
    }

    @media (min-width: 981px) and (max-width: 1200px) {
      .priceTemplate-item,
      .templateForm-item {
        .inputNumber._small .button,
        .inputNumber._small .input-field {
          height: var(--btn-height-regular);
          min-width: var(--btn-height-regular);
          min-height: var(--btn-height-regular);
        }

        .priceLabel,
        .priceComment,
        .inputRadio-label {
          font-size: 0.875rem;
        }

        .input._delivery-time {
          width: 4rem;

          .input-field {
            height: var(--btn-height-regular);
            min-height: var(--btn-height-regular);
          }
        }
      }
    }
  }
</style>
